//	ATtiny2313
//	aitendo/ZY-FGD1442701V1(ST7735) eXg
//	wt]xH쎺	http://jsdiy.web.fc2.com

/*
y|[gΉz	ATtiny2313	x:݂Ȃ(PA2RESET) -:
bit		7	6	5	4	3	2	1	0
portA	x	x	x	x	x	x	-	-
portB	D7	D6	D5	D4	D3	D2	D1	D0		LCD
portD	x	RST	RD	WR	D/C	CS	TXD	RXD		LCD,VAʐM

CS# = chip select		Hi:wait, Lo:enable
D/C# = data/command		Hi:data or param, Lo:command
WR = write	pX̗オdata荞ށ^RD̎HiɂĂ
RD = read	pX̗オdataω^WR̎HiɂĂ
RST# = reset	Hi:ʏ퓮쒆, Lo:n[hEFAZbg

VXeNbN8MHz  125ns/1cycle
RDȂ/WR݂̂̎gpƂāA^C~O`[gŎ^C~Oŏl̂AłԂ100nsiWR/TWC̎ԁjłB
VXeŐŏԂ͂蒷̂ŁAI/Os̏oHi/Lo̐؂ւ̓m[EFCgok.

yATtiny2313z
|-BBBBBBBBD|
|V765432106|
>          |
|201102345G|
|ADDAADDDD-|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100100(64)
Low: 11100100 (E4)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PD2ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11111 (DF)
     |||||||+-- RSTDISBL (RESETs 1:L, 0:(PA2))
     ||||+++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3)
     |||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- EESAVE (EEPROM 1:, 0:ێ)
     +-- DWEN (On-ChipfobO 1:, 0:L)

Ext: -------1 (FF)
            +-- SPMEN (SPM 1:, 0:L)

yrhz
Atmel Studio 6 (Version: 6.0.1996 - Service Pack 2)
AVR Toolchain 8 Bit / Version: 3.4.1.830 - GCC  4.6.2
ATtiny2313 8MHz/Ȃ	œKIvV: -Os

yXVz
2013/05/29	v1.00	
	Program Memory Usage 	:	662 bytes   32.3 % Full
	Data Memory Usage 		:	11 bytes   8.6 % Full
	
2013/06/02	v2.00	摜f[^oCi`œ]悤ɉB
	Program Memory Usage 	:	824 bytes   40.2 % Full
	Data Memory Usage 		:	107 bytes   83.6 % Full
	
2013/06/04	v2.10	艻B\[XB
	Program Memory Usage 	:	782 bytes   38.2 % Full
	Data Memory Usage 		:	106 bytes   82.8 % Full
*/

#include <avr/io.h>
#include <util/delay.h>
#include "comctrl.h"

#define LCD_CS	(1 << PD2)
#define LCD_DC	(1 << PD3)
#define LCD_WR	(1 << PD4)
#define	LCD_RD	(1 << PD5)
#define	LCD_RESET	(1 << PD6)
#define lcdSetBitHi(bitValue)	{ PORTD |= (bitValue); }
#define lcdSetBitLo(bitValue)	{ PORTD &= ~(bitValue); }
#define lcdSetByte(byteData)	{ PORTB = (byteData); }

//LCDZbg
static	void	lcdReset()
{
	lcdSetBitLo(LCD_RESET);
	_delay_ms(10);
	lcdSetBitHi(LCD_RESET);
}

//f[^|[g8bit̒lo͂
static	void	lcdWriteBits(uint8_t bits)
{
	lcdSetBitLo(LCD_WR);
	lcdSetByte(bits);
	lcdSetBitHi(LCD_WR);
}

//LCDR}ho͂
static	void	lcdCmd(uint8_t cmd)
{
	lcdSetBitLo(LCD_DC);
	lcdSetBitLo(LCD_CS);
	lcdWriteBits(cmd);
	lcdSetBitHi(LCD_CS);
}

//LCDf[^A܂́ALCDR}h̃p[^o͂
static	void	lcdDataByte(uint8_t data)
{
	lcdSetBitHi(LCD_DC);
	lcdSetBitLo(LCD_CS);
	lcdWriteBits(data);
	lcdSetBitHi(LCD_CS);
}

static	void	lcdDataWord(uint8_t dataH, uint8_t dataL, uint16_t length)
{
	uint16_t i;
	lcdSetBitHi(LCD_DC);
	lcdSetBitLo(LCD_CS);
	for (i = 0; i < length; i++)
	{
		lcdWriteBits(dataH);
		lcdWriteBits(dataL);
	}		
	lcdSetBitHi(LCD_CS);
}

static	uint8_t	*byteDatas;
static	void	lcdDataByteArray(uint16_t length)
{
	uint16_t i;
	lcdSetBitHi(LCD_DC);
	lcdSetBitLo(LCD_CS);
	for (i = 0; i < length; i++)
		lcdWriteBits(byteDatas[i]);
	lcdSetBitHi(LCD_CS);
}

int main(void)
{
	uint8_t		reqCommand, u8tmp, u8tmp2;
	uint16_t	wlength = 0;
	
	byteDatas = comGetDataBuf();

	//VA|[g
	comInit();
	
	DDRB = 0b11111111;	//LCDf[^|[g
	DDRD = LCD_RESET | LCD_RD | LCD_WR | LCD_DC | LCD_CS;	//LCD|[g
	
	//LCDZbg
	_delay_ms(100);	//LCDւ̓d҂̂
	lcdReset();
	
	lcdSetByte(0x00);
	lcdSetBitHi(LCD_RD | LCD_WR | LCD_CS);
	lcdSetBitLo(LCD_DC);

	//gpsvAbvĂ
	PORTA = (1 << PA1) | (1 << PA0);
	
	while (1)
    {
		//R}h҂
		reqCommand = comPolling();
		if (!comCmdExec(reqCommand)) continue;
		
		//̐U蕪
		//Eǂݍ݌n͎擾f[^ԂB
		//E݌n͏̍}ƂĎg̃R}hԂB
		switch (reqCommand)
		{
		case COMCTRL_LCD_CMD:
			u8tmp = comGetByte(0);
			lcdCmd(u8tmp);
			comSendByte(COMCTRL_LCD_CMD);
			break;
			
		case COMCTRL_LCD_BYTE:
			u8tmp = comGetByte(0);
			lcdDataByte(u8tmp);
			comSendByte(COMCTRL_LCD_BYTE);
			break;
			
		case COMCTRL_LCD_WORD_RLE:
			u8tmp = comGetByte(0);	//word-Hi
			u8tmp2 = comGetByte(1);	//word-Lo
			wlength = comGetWord(2);
			lcdDataWord(u8tmp, u8tmp2, wlength);
			comSendByte(COMCTRL_LCD_WORD_RLE);
			break;
			
		case COMCTRL_CMD_BINMODE:
			wlength = comGetByte(0);
			comChangeBinDataMode(wlength);
			comSendByte(COMCTRL_CMD_BINMODE);
			break;
			
		case COMCTRL_LCD_BINDATA:
			lcdDataByteArray(wlength);
			comSendByte(COMCTRL_LCD_BINDATA);
			break;
			
		case COMCTRL_RET_RCVERROR:
			comErrorReset();
			comSendByte(COMCTRL_RET_RCVERROR);
			break;
			
		case COMCTRL_CMD_WHO:
			comSendMyName();
			break;
		
		default:	break;
		}
		
		//R}hɉMĂĂƂ
		comUsartRcvBufClear();
		
		//R}h̕ԐM
		comSendByte(COMCTRL_END_CODE);
	}
	
	return 0;
}
